package com.ejie.ab63.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Ab6315s00  
 * 
 *  
 */

public class Especialidad implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private String idEspecialidad;
	private TipoEstablecimiento tipoEstablecimiento;
	private String descCategoriaEs;
	private Date fechaModificacion;
	private String nomUsuario;
	private Integer baja;
	private String descCategoriaEu;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private List<Establecimiento> listEstablecimiento = new ArrayList<Establecimiento>();

	/**
	 * Method 'Ab6315s00'.
	 */
	public Especialidad() {
	}

	/**
	 * Method 'Ab6315s00'.
	 * 
	 * @param idEspecialidad
	 *            String
	 */
	public Especialidad(String idEspecialidad) {
		this.idEspecialidad = idEspecialidad;
	}

	/**
	 * Method 'Ab6315s00'.
	 * 
	 * @param idEspecialidad
	 *            String
	 * @param descCategoriaEs
	 *            String
	 * @param fechaModificacion
	 *            Date
	 * @param nomUsuario
	 *            String
	 * @param baja
	 *            Integer
	 * @param descCategoriaEu
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param ab6311s00
	 *            Ab6311s00
	 */
	public Especialidad(String idEspecialidad, String descCategoriaEs, Date fechaModificacion, String nomUsuario,
			Integer baja, String descCategoriaEu, Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion,
			String usuarioUltmodificacion, TipoEstablecimiento ab6311s00) {
		this.idEspecialidad = idEspecialidad;
		this.tipoEstablecimiento = ab6311s00;
		this.descCategoriaEs = descCategoriaEs;
		this.fechaModificacion = fechaModificacion;
		this.nomUsuario = nomUsuario;
		this.baja = baja;
		this.descCategoriaEu = descCategoriaEu;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'Ab6315s00'.
	 * 
	 * @param idEspecialidad
	 *            String
	 * @param descCategoriaEs
	 *            String
	 * @param fechaModificacion
	 *            Date
	 * @param nomUsuario
	 *            String
	 * @param baja
	 *            Integer
	 * @param descCategoriaEu
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param ab6311s00
	 *            Ab6311s00
	 * @param ab6301s00s
	 *            List<Ab6301s00>
	 */
	public Especialidad(String idEspecialidad, String descCategoriaEs, Date fechaModificacion, String nomUsuario,
			Integer baja, String descCategoriaEu, Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion,
			String usuarioUltmodificacion, TipoEstablecimiento ab6311s00, List<Establecimiento> ab6301s00s) {

		this.idEspecialidad = idEspecialidad;
		this.tipoEstablecimiento = ab6311s00;
		this.descCategoriaEs = descCategoriaEs;
		this.fechaModificacion = fechaModificacion;
		this.nomUsuario = nomUsuario;
		this.baja = baja;
		this.descCategoriaEu = descCategoriaEu;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.listEstablecimiento = ab6301s00s;
	}

	/**
	 * Method 'getIdEspecialidad'.
	 *
	 * @return String
	 */

	public String getIdEspecialidad() {
		return this.idEspecialidad;
	}

	/**
	 * Method 'setIdEspecialidad'.
	 *
	 * @param idEspecialidad
	 *            String
	 * @return
	 */

	public void setIdEspecialidad(String idEspecialidad) {
		this.idEspecialidad = idEspecialidad;
	}

	/**
	 * Method 'getAb6311s00'.
	 *
	 * @return Ab6311s00
	 */

	public TipoEstablecimiento getTipoEstablecimiento() {
		return this.tipoEstablecimiento;
	}

	/**
	 * Method 'setAb6311s00'.
	 *
	 * @param ab6311s00
	 *            Ab6311s00
	 * @return
	 */

	public void setTipoEstablecimiento(TipoEstablecimiento ab6311s00) {
		this.tipoEstablecimiento = ab6311s00;
	}

	/**
	 * Method 'getDescCategoriaEs'.
	 *
	 * @return String
	 */

	public String getDescCategoriaEs() {
		return this.descCategoriaEs;
	}

	/**
	 * Method 'setDescCategoriaEs'.
	 *
	 * @param descCategoriaEs
	 *            String
	 * @return
	 */

	public void setDescCategoriaEs(String descCategoriaEs) {
		this.descCategoriaEs = descCategoriaEs;
	}

	/**
	 * Method 'getFechaModificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaModificacion() {
		return this.fechaModificacion;
	}

	/**
	 * Method 'setFechaModificacion'.
	 *
	 * @param fechaModificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaModificacion(Date fechaModificacion) {
		this.fechaModificacion = fechaModificacion;
	}

	/**
	 * Method 'getNomUsuario'.
	 *
	 * @return String
	 */

	public String getNomUsuario() {
		return this.nomUsuario;
	}

	/**
	 * Method 'setNomUsuario'.
	 *
	 * @param nomUsuario
	 *            String
	 * @return
	 */

	public void setNomUsuario(String nomUsuario) {
		this.nomUsuario = nomUsuario;
	}

	/**
	 * Method 'getBaja'.
	 *
	 * @return Integer
	 */

	public Integer getBaja() {
		return this.baja;
	}

	/**
	 * Method 'setBaja'.
	 *
	 * @param baja
	 *            Integer
	 * @return
	 */

	public void setBaja(Integer baja) {
		this.baja = baja;
	}

	/**
	 * Method 'getDescCategoriaEu'.
	 *
	 * @return String
	 */

	public String getDescCategoriaEu() {
		return this.descCategoriaEu;
	}

	/**
	 * Method 'setDescCategoriaEu'.
	 *
	 * @param descCategoriaEu
	 *            String
	 * @return
	 */

	public void setDescCategoriaEu(String descCategoriaEu) {
		this.descCategoriaEu = descCategoriaEu;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getAb6301s00s'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<Establecimiento> getListEstablecimiento() {
		return this.listEstablecimiento;
	}

	/**
	 * Method 'setAb6301s00s'.
	 *
	 * @param ab6301s00s
	 *            List
	 * @return
	 */
	public void setListEstablecimiento(List<Establecimiento> ab6301s00s) {
		this.listEstablecimiento = ab6301s00s;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idEspecialidad: ").append(this.idEspecialidad).append(" ]");
		result.append(", [ descCategoriaEs: ").append(this.descCategoriaEs).append(" ]");
		result.append(", [ fechaModificacion: ").append(this.fechaModificacion).append(" ]");
		result.append(", [ nomUsuario: ").append(this.nomUsuario).append(" ]");
		result.append(", [ baja: ").append(this.baja).append(" ]");
		result.append(", [ descCategoriaEu: ").append(this.descCategoriaEu).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

}
